export const colorLegend = (selection, props) => {
  const {colorScale, height, circleRadius, spacing,
        textOffset, backgroundRectWidth, onClick} = props;
  
  const backgroundRect = selection.selectAll('rect')
  	.data([null]);
  
  const n = colorScale.domain().length;
  backgroundRect.enter().append('rect')
  	.merge(backgroundRect)
  		.attr('x', -circleRadius * 2)
  		.attr('y', -circleRadius * 2)
  		.attr('rx', circleRadius * 2)
  		.attr('width', backgroundRectWidth)
  		.attr('height', spacing * n + circleRadius * 3)
  		.attr('fill', 'white')
  		.attr('opacity', 0.8);
  
  const groups = selection.selectAll('g')
  	.data(colorScale.domain());
  
	const groupEnter = groups.enter().append('g')
  	.attr('class', 'tick')
  	.attr('transform', (d,i) => 
          `translate(0, ${i*spacing+circleRadius})`)
  	.on('click',onClick)
 
  groups.exit().remove();
  
	groupEnter
    .append('circle')
  	.attr('r', 0)
  .merge(groups.select('circle'))	//both enter section and update section
  	.attr('fill', colorScale)
  .transition().duration(1000)
    .attr('r', circleRadius);
  
  const text = groups.select('text');
  
	groupEnter.append('text')
		.attr('x', textOffset)
  	.attr('dy', '0.32em')
  .merge(text)	//both enter section and update section
  	.text(d => typeof(d) === 'undefined'? 'undefined': d)
   
}